var search_bc = {
  onLoad: function() {
    // initialization code
		window.removeEventListener("load",search_bc.onLoad,0);
    this.initialized = true;
    this.strings = document.getElementById("search_bc-strings");
		this.exeFile = null;
		document.getElementById("contentAreaContextMenu")
            .addEventListener("popupshowing", function(e) { search_bc.showContextMenu(e); }, false);
						
		try{
			
// Workaround code using uninstall path. Part of this code was modified from SpinMachine's original BitChe It plugin

var wrk = Components.classes["@mozilla.org/windows-registry-key;1"]
                    .createInstance(Components.interfaces.nsIWindowsRegKey);

var path = null;
wrk.open(wrk.ROOT_KEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft", wrk.ACCESS_READ);

if (wrk.hasChild("Windows")) {
  var subkey = wrk.openChild("Windows\\CurrentVersion\\Uninstall\\{D9DA5C41-964F-455F-B5E7-3664519440E8}_is1", wrk.ACCESS_READ);
  if (subkey.hasValue("installlocation"))
  {
    path = subkey.readStringValue("installlocation");
  }else{
    alert("Error: Bit Che installation directory not found!");
  }
}

wrk.close();

if(!path){
	return;
}

path = path + '\\' + "Bit_Che.exe";


// Old code that uses the BC:// handler path to find Bit Che
//
//			var wrk = Components.classes["@mozilla.org/windows-registry-key;1"]
//                   .createInstance(Components.interfaces.nsIWindowsRegKey);
//			wrk.open(wrk.ROOT_KEY_CLASSES_ROOT,
//							 "bc\\shell\\open\\command",
//							 wrk.ACCESS_READ);
//			
//			var path = null;
//			for (var i=0; i<wrk.valueCount; i++) {
//				var name = wrk.getValueName(i);
//				var value = wrk.readStringValue(name);
//				path = value;
//			}
//			wrk.close();
//			
//			if(!path){
//				return;
//			}
//			
//			path  = path.substring(1,path.length);
//			path = path.substring(0,path.indexOf('"'));


			
			var file = Components.classes["@mozilla.org/file/local;1"]
                           .createInstance(Components.interfaces.nsILocalFile);
      file.initWithPath(path);
			
			this.exeFile = file;
		
		}catch(e){
			//alert(e);
		}
  },

	showContextMenu: function(event) {
		search_bc.selection = null;
		if (event.target.id != 'contentAreaContextMenu') return;
		var popupnode = document.popupNode;
		var nodeLocalName = popupnode.localName.toLowerCase();
		var selection = null;
		if ((nodeLocalName == "textarea") || (nodeLocalName == "input" && popupnode.type == "text")) {
      selection = popupnode.value.substring(popupnode.selectionStart, popupnode.selectionEnd);
		}else if (nodeLocalName == "img") {
        if (popupnode.title)
            selection = popupnode.title;
        else if (popupnode.alt)
            selection = popupnode.alt;
        else
         selection = '';
		} else {
			var focusedWindow = document.commandDispatcher.focusedWindow;
			selection = focusedWindow.getSelection().toString();
		}
		
		if (selection && selection != '') {
			var label= this.strings.getFormattedString('context.label',[selection]);
			document.getElementById("context-search_bc").label = label;
			document.getElementById("context-search_bc").hidden = false;
			search_bc.selection = selection;
		} else {
			document.getElementById("context-search_bc").hidden = true;
		}
	},
	
	onShellExec: function(event){
		if(search_bc.selection && search_bc.exeFile){
			var selection = search_bc.selection;
			
			try{
         // create an nsIProcess
         var process = Components.classes["@mozilla.org/process/util;1"]
                           .createInstance(Components.interfaces.nsIProcess);
                                 
	process.init(search_bc.exeFile);
      
         // Run the process.
         // If first param is true, calling process will be blocked until
         // called process terminates.
         // Second and third params are used to pass command-line arguments
         // to the process.
				 
         process.run(false, [search_bc.selection], 1);
      }
      catch(e){
				//alert(e);
			}
		}
	}
};

function trim(str) {
    var x = str;
    x = x.replace(/^\s*(.*)/, "$1");
    x = x.replace(/(.*?)\s*$/, "$1");
    return x;
}

window.addEventListener("load", function(e) { search_bc.onLoad(e); }, false);
